#include <iostream>
#include <deque>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
 
using namespace std;
 
#define li long long
#define rep(n) for(li i = 0; i < n; i++)

bool good(vector<li> guys, map<li, vector<li>> d)
{
    vector <li> ourEnemies;
    for(li i = 0; i < guys.size(); i++)
    {
        li e = guys[i];
        for(li q = 0; q < ourEnemies.size(); q++)
        {
            if(ourEnemies[q] == e)
                return false;
        }
        vector <li> enemies = d[e];
        ourEnemies.insert(ourEnemies.end(), enemies.begin(), enemies.end());
    }
    return true;
}

int main()
{
	li n;
	cin >> n;

	li * u = new li[n];
	rep(n)
		u[i] = 0;
	map<li, vector<li>> d;
	bool isGroup2 = true;
	rep(n)
	{
		li t;
		cin >> t;
		if(i == 0 && t != -1)
			isGroup2 = false;
		else if(i != 0 && t != i)
			isGroup2 = false;

		if(t != -1)
		{
			d[i].push_back(t - 1);
			d[t - 1].push_back(i);
			u[i]++;
			u[t - 1]++;
		}
	}
	if(isGroup2)
		cout << ceil(n / 2.0) << endl;
	else
	{
		// Assume group 3
		vector<li> guys;
		rep(n)
			guys.push_back(i);
		while(!good(guys, d))
		{
			li ri = 0;
			if(u[guys[0]] <= u[guys[1]] - 1)
				ri = 1;

			guys.erase(guys.begin() + ri);
			for(li i = 0; i < u[ri]; i++)
			{
				u[d[ri][i]]--;
				u[ri]--;
			}
		}
		cout << guys.size() << endl;
	}
	// system("pause");
	return 0;
}