#include <iostream>
#include <deque>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
 
using namespace std;
 
#define li long long
#define rep(n) for(li i = 0; i < n; i++)

bool good(vector<li> guys, map<li, vector<li>> d)
{
	vector <li> ourEnemies;
	for(li i = 0; i < guys.size(); i++)
	{
		li e = guys[i];
		for(li q = 0; q < ourEnemies.size(); q++)
		{
			if(ourEnemies[q] == e)
				return false;
		}
		vector <li> enemies = d[e];
		ourEnemies.insert(ourEnemies.end(), enemies.begin(), enemies.end());
	}
	return true;
}

int main()
{
	li n;
	cin >> n;

	li * u = new li[n];
	rep(n)
		u[i] = 0;
	map<li, vector<li>> d;
	rep(n)
	{
		li t;
		cin >> t;
		if(t != -1)
		{
			d[i].push_back(t - 1);
			d[t - 1].push_back(i);
			u[i]++;
			u[t - 1]++;
		}
	}
	vector <li> guys;
	rep(n)
		guys.push_back(i);
	while(!good(guys, d))
	{
		li mi = -1;
		li mx = -1;
		for(li i = 0; i < guys.size(); i++)
		{
			if(mx < u[guys[i]]) {
				mx = u[i];
				mi = i;
			}
		}
		guys.erase(guys.begin() + mi);
	}
	cout << guys.size() << endl;
	// system("pause");
	return 0;
}